#pragma once

#include "Mix/Tool/CLR/Core/Utility/DefinitionOrderTypeConverter.h"
#include "Mix/Tool/CLR/Core/Dynamics/Joint.h"

using namespace System::ComponentModel;

namespace Mix{ namespace Tool{ namespace Win32{ namespace Dynamics{
	class HingeJoint;
}}}}

namespace Mix{ namespace Tool{ namespace Dynamics{

	[TypeConverter(Mix::Tool::Utility::DefinitionOrderTypeConverter::typeid)]
	public ref class HingeJoint : public Mix::Tool::Dynamics::Joint
	{
	private:
		Mix::Tool::Win32::Dynamics::HingeJoint* impl;

	public:
		HingeJoint( void );
		HingeJoint( Mix::Tool::Math::Vector^ axis, float lowerLimit, float upperLimit, bool collisionDisabled, float limitSpring, float limitDamper );
		virtual ~HingeJoint( void );

		[Category("\t\t{")]
		[Description( L"w肵܂B" )]
		[TypeConverter(Mix::Tool::Math::VectorConverter::typeid)]
		property Mix::Tool::Math::Vector^ Axis
		{
			Mix::Tool::Math::Vector^ get( void );
			void set( Mix::Tool::Math::Vector^ value );
		}

		[Category("\t\t{")]
		[Description( L"]̍ŏpxw肵܂B" )]
		property float LowerLimit
		{
			float get( void );
			void set( float value );
		}

		[Category("\t\t{")]
		[Description( L"]̍őpxw肵܂B" )]
		property float UpperLimit
		{
			float get( void );
			void set( float value );
		}

		[Category("\tTXyV")]
		[Description( L"~bg( ]̍ŏAőpx )ɉeol̂炩w肵܂B" )]
		property float LimitSpring
		{
			float get( void );
			void set( float value );
		}

		[Category("\tTXyV")]
		[Description( L"~bg( ]̍ŏAőpx )ɉe_p[̌͂w肵܂B" )]
		property float LimitDamper
		{
			float get( void );
			void set( float value );
		}
/*
		[Category("̑")]
		property float NormalSpring
		{
			float get( void );
			void set( float value );
		}
*/

	public:
		[Browsable(false)]
		property bool CollisionDisabled
		{
			virtual bool get( void ) override;
			virtual void set( bool value ) override;
		}

	internal:
		property Mix::Tool::Win32::Dynamics::Joint* Impl
		{
			virtual Mix::Tool::Win32::Dynamics::Joint* get( void ) override;
		}
	};

}}}
