#pragma once


#include "Mix/Tool/CLR/Core/Dynamics/CollisionObject.h"

using namespace System::ComponentModel;

namespace Mix{ namespace Tool{ namespace Win32{ namespace Dynamics{
	class KinematicCharacter;
}}}}

namespace Mix{ namespace Tool{ namespace Dynamics{

	ref class PhysicsMaterial;

	public ref class KinematicCharacter : public Mix::Tool::Dynamics::CollisionObject
	{
	private:
		Mix::Tool::Win32::Dynamics::KinematicCharacter* impl;
		bool m_bInternalImpl;
		Mix::Tool::Dynamics::PhysicsMaterial^ m_PhysicsMaterial;

	internal:
		KinematicCharacter( Mix::Tool::Win32::Dynamics::KinematicCharacter* _impl );

		property Mix::Tool::Win32::Dynamics::KinematicCharacter* ImplW32KinematicCharacter
		{
			Mix::Tool::Win32::Dynamics::KinematicCharacter* get( void );
		}

	public:
		KinematicCharacter( void );
		~KinematicCharacter( void );

		[Category("\t\t`")]
		[Description( L"JvZ̍w肵܂B" )]
		property float Height
		{
			float get( void );
			void set( float value );
		}

		[Category("\t\t`")]
		[Description( L"JvZ̔aw肵܂B" )]
		property float Radius
		{
			float get( void );
			void set( float value );
		}

		[Category("\t")]
		[Description( L"d͂w肵܂B" )]
		property float Gravity
		{
			float get( void );
			void set( float value );
		}

		[Category("\t")]
		[Description( L"ő嗎xw肵܂B" )]
		property float MaxFallSpeed
		{
			float get( void );
			void set( float value );
		}

		[Category("\t")]
		[Description( L"Wv̏w肵܂B" )]
		property float InitJumpSpeed
		{
			float get( void );
			void set( float value );
		}

		[Category("\t")]
		[Description( L"i̍w肵܂B" )]
		property float StepOffset
		{
			float get( void );
			void set( float value );
		}

		[Category("\t")]
		[Description( L"z̊pxw肵܂B" )]
		property float SlopeLimit
		{
			float get( void );
			void set( float value );
		}

		[Browsable(false)]
		property Mix::Tool::Dynamics::PhysicsMaterial^ PhysicsMaterial
		{
			Mix::Tool::Dynamics::PhysicsMaterial^ get( void );
			void set( Mix::Tool::Dynamics::PhysicsMaterial^ value );
		}

		[Browsable(false)]
		property bool IsGround
		{
			bool get( void );
		}

		void Jump( void );

	private:
		void PhysicsMaterial_ValueChanged( System::Object^ sender, System::EventArgs^ e );

	internal:
		property Mix::Tool::Win32::Dynamics::CollisionObject* Impl
		{
			virtual Mix::Tool::Win32::Dynamics::CollisionObject* get( void ) override;
		}
	};

}}}
